/// <reference types="node" />
import { IncomingMessage, ServerResponse, IncomingHttpHeaders, Server } from 'http';
export { IncomingMessage, ServerResponse, IncomingHttpHeaders, Server };
export interface IncomingOpts {
    limit?: string | number;
    encoding?: string | null;
}
export declare type MicriHandler = (req: IncomingMessage, res: ServerResponse) => any;
export declare class MicriError extends Error {
    statusCode: number;
    code: string;
    originalError: Error | null;
    constructor(statusCode: number, code: string, message: string, originalError?: Error);
}
export declare function send(res: ServerResponse, statusCode: number, obj?: any): void;
export declare const sendError: (req: IncomingMessage, res: ServerResponse, errorObj: Error | MicriError) => void;
export declare function run(req: IncomingMessage, res: ServerResponse, fn: MicriHandler): Promise<void>;
export declare function buffer(req: IncomingMessage, { limit }?: IncomingOpts): Promise<Buffer>;
export declare function text(req: IncomingMessage, { limit, encoding }?: IncomingOpts): Promise<string>;
export declare function json(req: IncomingMessage, opts?: IncomingOpts): Promise<any>;
export declare const serve: (fn: MicriHandler) => Server;
export default serve;
